package com.ruoyi.jjh.declaration.single.controller;

import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.jjh.declaration.single.dto.response.ChiefResponse;
import com.ruoyi.jjh.declaration.single.service.SingleLoginService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.DigestUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 政务端登录
 * @author du
 * @since 2024/6/4 9:53
 */
@Api(tags = "政务端单点登录")
@RequestMapping("/system/chief")
@RestController
public class ChiefController {

    @Value("${appkey}")
    private String appkey;

    @Value("${zwUrl}")
    private String zwUrl;

    @Resource
    private SingleLoginService singleLoginService;

    @ApiOperation("政务端登录")
    @GetMapping
    public AjaxResult login(
            @RequestParam("accountName") String accountName,
            @RequestParam("timestamp") String timestamp,
            @RequestParam("sign") String sign,
            @RequestParam("loginType") String loginType
    )  {
        String md5 = accountName+timestamp;
        String md5Password = DigestUtils.md5DigestAsHex(md5.getBytes());
        if(md5Password.equals(sign.toLowerCase())){
            //政务端获取用户信息
            String url = zwUrl + "?accountName=" + accountName +"&appkey"+appkey;
            HttpResponse response = HttpUtil.createGet(url).execute();
            // 获取响应状态码
            int statusCode = response.getStatus();
            if (statusCode == 200) {
                String responseBody = response.body();
                JSONObject jsonObj = JSONUtil.parseObj(responseBody);
                JSONObject dataObj = jsonObj.getJSONObject("data");
                ChiefResponse req = JSONUtil.toBean(dataObj, ChiefResponse.class);
//                req.setToken(singleLoginService.singleLogin("1","2",null,"02"));
                //判断几个政务端用户
                return AjaxResult.success(req);
            }
        }else {
            //跳转到登录页面
        }
        return null;
    }

}
